/*
 * libconfigfile - configfile.h
 *	version 0.0.0
 *
 * Copyright (C) 2005  Krzysztof Mazur <krzysiek@podlesie.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * $Id: configfile.h,v 1.2 2005/06/15 13:23:45 krzysiek Exp $
 */

#ifndef CONFIGFILE_H_INCLUDED
#define CONFIGFILE_H_INCLUDED

struct cf_entry {
	char *name;	
	char *value;
	struct cf_entry *next;
};

struct cf_section {
	char *name;
	struct cf_entry *fe, *le;
	struct cf_section *next;
};

struct cf_space {
	struct cf_section *fs, *ls;
};

struct cf_section_mget_state {
	struct cf_section *sect;
};

struct cf_entry_mget_state {
	struct cf_entry *entry;
};

int cf_space_init(struct cf_space *space);
int cf_space_lock(struct cf_space *space);
int cf_space_unlock(struct cf_space *space);
int cf_space_loadfile(struct cf_space *space, const char *fname);
int cf_space_done(struct cf_space *space);

int cf_section_lock(struct cf_section *sect);
int cf_section_unlock(struct cf_section *sect);
struct cf_section *cf_section_get(struct cf_space *space, const char *name);

int cf_section_mget_init(struct cf_section_mget_state *state,
		struct cf_space *space, const char *name);
struct cf_section *cf_section_mget_get(struct cf_section_mget_state *state);
int cf_section_mget_done(struct cf_section_mget_state *state);

int cf_entry_lock(struct cf_section *sect);
int cf_entry_unlock(struct cf_section *sect);
struct cf_entry *cf_entry_get(struct cf_section *section, const char *name);
const char *cf_entry_get_value(struct cf_section *section, const char *name);
int cf_entry_mget_init(struct cf_entry_mget_state *state,
		struct cf_section *sect, const char *name);
struct cf_entry *cf_entry_mget_get(struct cf_entry_mget_state *state);
const char *cf_entry_mget_get_value(struct cf_entry_mget_state *state);
int cf_entry_mget_done(struct cf_entry_mget_state *state);

const char *cf_get_value(struct cf_space *space, const char *section_name,
		const char *entry_name);

#endif
